#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_Icon=icons\prog.ico
#AutoIt3Wrapper_Outfile=Starplayer.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Starplayer
#AutoIt3Wrapper_Res_Fileversion=2.7.1.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs
	Attention! Attention! Attention!
	This Script requires min. AutoIt Version 3.3.1.0 beta
#ce

; Includes
#include <ComboConstants.au3>
#include <GuiComboBox.au3>
#include <Date.au3>
#include <File.au3>
#include <String.au3>
#include <EditConstants.au3>
#include <Constants.au3>
#include <Array.au3>
#include <GUIConstantsEx.au3>
#include <ButtonConstants.au3>
#include <GuiListView.au3>
#include <ListViewConstants.au3>
#include <ProgressConstants.au3>
#include <SliderConstants.au3>
#include <Sound.au3>
#include <StaticConstants.au3>
#include <StructureConstants.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include <Timers.au3>
#include 'get_mp3_info.au3'
#include 'bass\Bass.au3'
#include 'bass\BassEnc.au3'

; Options
Opt('GUIOnEventMode', 1)
Opt('GUICloseOnESC', 0)
Opt('TrayOnEventMode', 1)
Opt('TrayAutoPause', 0)
Opt('TrayMenuMode', 1)

Global $sTitle = 'Starplayer v2.71'
Global $iSelfPID = _WinAPI_GetCurrentProcessID()
Global $aProcessList = ProcessList('Starplayer.exe')
If $aProcessList[0][0] > 1 Then
	If $iSelfPID <> $aProcessList[1][1] Then WinWait($sTitle)
EndIf
If WinExists($sTitle) Then ; If Starplayer exists, then send Commandline to 1st instance.
	If $CmdLine[0] > 0 Then
		For $i = 1 To $CmdLine[0]
			If FileExists($CmdLine[$i]) Then
				Switch StringRight($CmdLine[$i], 4)
					Case '.mp3', '.m3u'
						ControlCommand($sTitle, '', '[CLASS:Edit; INSTANCE:3]', 'EditPaste', $CmdLine[$i] & @CRLF)
				EndSwitch
			EndIf
		Next
	EndIf
	Exit ; Only one instance. Exit the 2nd.
EndIf

; OS-Check
Switch @OSVersion
	Case 'WIN_VISTA', 'WIN_7'
		Global $aID3Index[5] = [21, 13, 27, 28, 14] ; Title, Artists, Duration, Bitrate, Album
	Case 'WIN_XP', 'WIN_2003'
		Global $aID3Index[5] = [10, 16, 21, 22, 17] ; Title, Artists, Duration, Bitrate, Album
	Case 'WIN_2000'
		Global $aID3Index[5] = [11, 10, 33, 30, 19] ; Title, Artists, Duration, Bitrate, Album
	Case Else
		Exit MsgBox(16, $sTitle, 'Your Windows-Version is not compatible with this program!')
EndSwitch

; Open Bass DLLs
$bass_dll = DllOpen(@ScriptDir & '\bass\BASS.dll')
$basscb_dll = DllOpen(@ScriptDir & '\bass\BASSCB.dll')
$bassenc_dll = DllOpen(@ScriptDir & '\bass\BASSENC.dll')

; Color-Definition
Global $iGuiBkColor = 0xCFB8A0 ; GUI Background
Global $iLvBkColor = 0xFFFFDD ; Listview Background
Global $iLvMarkColor = 0xFFAE38 ; Listview Mark-Item
Global $iVolProgrColor = 0x5577AA ; Volume Progressbar
Global $iVolProgrBkColor = 0xFFFFFF ; Volume Background
Global $iVolProgrMuteColor = 0xE04040 ; Volume Background on mute
Global $iProgrColor = 0xFF8E18 ; Song Progressbar
Global $iProgrBkColor = 0xFFFFDD ; Song Progress Background
Global $iStatusBkColor = 0xEEEEEE ; Statusbar Background
Global $iPeakColor = 0x44CC44 ; VU-Meter Color
Global $iPeakBKColor = 0xFFFFDD ; VU-Meter Background

; Repeat Up-/Down-Button
Global $iButtonDownDelay = 250 ; Time (in Milliseconds) before button repeat
Global $iButtonRepeatDelay = 50 ; Time (in Milliseconds) between repeat

; Global Variable and IniRead
Global $sFullVersion = '2.7.1.0 (05.10.2009)'
Global $sIconDir = @ScriptDir & '\icons\'
Global $sAppDir = @AppDataDir & '\Starplayer2\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sInifile = $sAppDir & 'Starplayer.ini'
Global $sAutoM3U = $sAppDir & 'Autosave.m3u'
Global $sIniVersion = IniRead($sInifile, 'Program', 'Version', '0.0.0.0 (00.00.0000)')
If _VersionOld($sIniVersion, $sFullVersion) Then
	If FileExists($sInifile) Then FileDelete($sInifile)
	IniWrite($sInifile, 'Program', 'Version', $sFullVersion)
EndIf
Global $iMainPosX = IniRead($sInifile, 'Settings', 'MainPosX', @DesktopWidth / 2 - 315)
Global $iMainPosY = IniRead($sInifile, 'Settings', 'MainPosY', @DesktopHeight / 2 - 180)
Global $aDesktopRes = _GetDesktopResolution()
If $iMainPosX < $aDesktopRes[0] Or $iMainPosX > $aDesktopRes[2] Or $iMainPosY < $aDesktopRes[1] Or $iMainPosY > $aDesktopRes[3] Then
	$iMainPosX = @DesktopWidth / 2 - 315
	$iMainPosY = @DesktopHeight / 2 - 180
	IniWrite($sInifile, 'Settings', 'MainPosX', $iMainPosX)
	IniWrite($sInifile, 'Settings', 'MainPosY', $iMainPosY)
EndIf
Global $bOnTop = Execute(IniRead($sInifile, 'Settings', 'OnTop', True))
Global $bRepeat = Execute(IniRead($sInifile, 'Settings', 'PlaylistRepeat', False))
Global $bMin2Tray = Execute(IniRead($sInifile, 'Settings', 'Min2Tray', True))
Global $bDblClPlay = Execute(IniRead($sInifile, 'Settings', 'DblClPlay', False))
Global $bLastPlaylist = Execute(IniRead($sInifile, 'Settings', 'LastPlaylist', False))
Global $sPathFiles = IniRead($sInifile, 'Settings', 'PathFiles', @MyDocumentsDir)
Global $sPathExport = IniRead($sInifile, 'Settings', 'PathExport', @MyDocumentsDir)
Global $sPathPlaylist = IniRead($sInifile, 'Settings', 'PathPlaylist', @MyDocumentsDir)
Global $bTooltips = Execute(IniRead($sInifile, 'Settings', 'Tooltips', True))
Global $iStdVolume = _SoundGetWaveVolume()
Global $iVolume = IniRead($sInifile, 'Settings', 'Volume', $iStdVolume)
Global $iOldHoverID, $ahLVItems[1]
Global $oShellApp = ObjCreate('Shell.Application')
Global $bMute = False, $iMuteVol = $iVolume, $bNext = False, $iLVCount = 0
Global $iPlayIndexNr = -1, $iPlayPosition = 0, $hPlayHandle = -1, $bPlayPause = False, $iOldPos, $iPlSize = 0
Global $gaDropFiles[1], $iDropItem = -1, $aDragItem
Global Const $WM_DROPFILES = 0x233

; create Tray
TraySetClick(16)
TraySetIcon($sIconDir & 'prog.ico')
TraySetOnEvent($TRAY_EVENT_PRIMARYDOUBLE, '_Restore')
TrayCreateItem($sTitle)
TrayItemSetState(-1, $TRAY_DISABLE)
TrayCreateItem('')
TrayCreateItem('Restore')
TrayItemSetOnEvent(-1, '_Restore')
TrayCreateItem('Exit')
TrayItemSetOnEvent(-1, '_End')
Opt('TrayIconHide', 1)

; create GUI
$hGui = GUICreate($sTitle, 630, 440, $iMainPosX, $iMainPosY, Default, $WS_EX_ACCEPTFILES)
GUISetOnEvent($GUI_EVENT_MOUSEMOVE, '_MouseHover')
GUISetOnEvent($GUI_EVENT_PRIMARYUP, '_SetPos')
GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, '_ButtonRepeat')
GUISetOnEvent($GUI_EVENT_DROPPED, '_DropEvent')
GUISetOnEvent($GUI_EVENT_MINIMIZE, '_Minimize')
GUISetOnEvent($GUI_EVENT_RESTORE, '_Restore')
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor($iGuiBkColor)
GUISetIcon($sIconDir & 'prog.ico')

; create Menu
$hMFile = GUICtrlCreateMenu('File')
$hmFileNew = GUICtrlCreateMenuItem('Create new Playlist', $hMFile)
GUICtrlSetOnEvent(-1, '_NewPlaylist')
$hMFileOpen = GUICtrlCreateMenuItem('Open Playlist...', $hMFile)
GUICtrlSetOnEvent(-1, '_OpenPlaylist')
$hMFileSave = GUICtrlCreateMenuItem('Save Playlist...', $hMFile)
GUICtrlSetOnEvent(-1, '_SavePlaylist')
$hMFileExport = GUICtrlCreateMenuItem('Export Playlist to...', $hMFile)
GUICtrlSetOnEvent(-1, '_ExportPlaylist')
$hMFileAdd = GUICtrlCreateMenuItem('Add File(s) to Playlist...', $hMFile)
GUICtrlSetOnEvent(-1, '_AddFile')
$hMFileDel = GUICtrlCreateMenuItem('Remove File(s) from Playlist...', $hMFile)
GUICtrlSetOnEvent(-1, '_DelFile')
GUICtrlCreateMenuItem('', $hMFile)
$hMFileExit = GUICtrlCreateMenuItem('Exit', $hMFile)
GUICtrlSetOnEvent(-1, '_End')
$hMOptions = GUICtrlCreateMenu('Options')
$hMOptionsSelAudio = GUICtrlCreateMenuItem('Select Audio-Device for VU-Meter', $hMOptions)
GUICtrlSetOnEvent(-1, '_SelectAudioDevice')
$hMOptionsOnTop = GUICtrlCreateMenuItem('Always on top', $hMOptions)
GUICtrlSetOnEvent(-1, '_SetOnTop')
$hMOptionsMin2Tray = GUICtrlCreateMenuItem('Minimize to Tray', $hMOptions)
GUICtrlSetOnEvent(-1, '_Min2Tray')
$hMOptionsDblClPlay = GUICtrlCreateMenuItem('Play Title immediately when doubleclick in Explorer', $hMOptions)
GUICtrlSetOnEvent(-1, '_DblClPlay')
$hMOptionsRegFileType = GUICtrlCreateMenuItem('Register ".mp3" and ".m3u" to Starplayer', $hMOptions)
GUICtrlSetOnEvent(-1, '_RegisterFiletype')
$hMAbout = GUICtrlCreateMenu('About')
GUICtrlCreateMenuItem($sTitle, $hMAbout)
GUICtrlCreateMenuItem(Chr(169) & ' by Oscar (www.autoit.de)', $hMAbout)
GUICtrlCreateMenuItem('Full Version: ' & $sFullVersion, $hMAbout)
$hMCredits = GUICtrlCreateMenu('Credits')
GUICtrlCreateMenuItem('Special thanks to:', $hMCredits)
GUICtrlCreateMenuItem('   - Jonathan Bennett and the AutoIt Team for AutoIt v3', $hMCredits)
GUICtrlCreateMenuItem('   - Brett Francis for the bass.au3', $hMCredits)
GUICtrlCreateMenuItem('   - Eukalyptus for BassEnc.au3 and the great VU-Meter example', $hMCredits)
GUICtrlCreateMenuItem('   - Gun-Food and peethebee for the great Forum (www.autoit.de)', $hMCredits)
GUICtrlCreateMenuItem('   - and to all the Users, who tested my program', $hMCredits)


; create Listview
$LV_Style = BitOR($LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER)
$LV_EX_STYLE = BitOR($WS_EX_CLIENTEDGE, $LVS_EX_FULLROWSELECT, $LVS_EX_DOUBLEBUFFER)
$hListview = GUICtrlCreateListView('Title|Artist|Album|Duration|Bitrate|Path', 45, 10, 525, 200, $LV_Style, $LV_EX_STYLE)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)
GUICtrlSetBkColor(-1, $iLvBkColor)
GUICtrlSendMsg($hListview, $LVM_SETCOLUMNWIDTH, 0, 180)
GUICtrlSendMsg($hListview, $LVM_SETCOLUMNWIDTH, 1, 180)
GUICtrlSendMsg($hListview, $LVM_SETCOLUMNWIDTH, 2, 180)
GUICtrlSendMsg($hListview, $LVM_SETCOLUMNWIDTH, 3, 80)
GUICtrlSendMsg($hListview, $LVM_SETCOLUMNWIDTH, 4, 80)
GUICtrlSendMsg($hListview, $LVM_SETCOLUMNWIDTH, 5, 300)

; create Up-/Down-Buttons
$hUp = GUICtrlCreateButton('', 5, 64, 35, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'up0.ico')
If $bTooltips Then GUICtrlSetTip(-1, 'Move the selected Title one row up')
GUICtrlSetOnEvent(-1, '_SelUp')
$hDown = GUICtrlCreateButton('', 5, 120, 35, 48, $BS_ICON)
GUICtrlSetImage(-1, $sIconDir & 'down0.ico')
If $bTooltips Then GUICtrlSetTip(-1, 'Move the selected Title one row down')
GUICtrlSetOnEvent(-1, '_SelDown')

; create Volume-Progress
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; Classic-Style
$hVolDisplay = GUICtrlCreateProgress(588, 10, 26, 272, BitOR($PBS_SMOOTH, $PBS_VERTICAL))
GUICtrlSetBkColor(-1, $iVolProgrBkColor)
GUICtrlSetColor(-1, $iVolProgrColor)
If $bTooltips Then GUICtrlSetTip(-1, 'Volume Control')
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; Standard-Windows-Style
$hVolControl = GUICtrlCreateSlider(570, 10, 10, 100, $TBS_VERT)
GUICtrlSetOnEvent(-1, '_VolControl')
GUICtrlSetState(-1, $GUI_HIDE)
$hVolIcon = GUICtrlCreateIcon($sIconDir & 'volcontrol1.ico', -1, 578, 300, 48, 48)
GUICtrlSetOnEvent(-1, '_VolMute')
If $bTooltips Then GUICtrlSetTip(-1, 'Mute on/off')

; create Duration-Group
GUICtrlCreateGroup('Duration', 10, 215, 120, 40)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
$hDisplayTime = GUICtrlCreateLabel('00:00 / 00:00', 17, 230, 110, 20, $SS_CENTER)
GUICtrlSetFont(-1, 14, 400, 0, 'Times New Roman')
GUICtrlCreateGroup('', -99, -99, 1, 1)

; create Title-Artist-Group
GUICtrlCreateGroup('Title - Artist', 140, 215, 430, 40)
GUICtrlSetFont(-1, 9, 400, 0, 'Verdana')
$hDisplayTitle = GUICtrlCreateLabel('', 147, 230, 415, 20)
GUICtrlSetFont(-1, 12, 400, 0, 'Times New Roman')
GUICtrlCreateGroup('', -99, -99, 1, 1)

; create Song-Progress
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; Classic-Style
$hProgress = GUICtrlCreateProgress(10, 265, 560, 16, $PBS_SMOOTH)
GUICtrlSetBkColor(-1, $iProgrBkColor)
GUICtrlSetColor(-1, $iProgrColor)
If $bTooltips Then GUICtrlSetTip(-1, 'Mouseklick on the Progressbar jumps' & @CR & 'to the corresponding Songposition')
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; Standard-Windows-Style

GUICtrlCreateLabel('', 0, 293, 630, 2, $SS_SUNKEN)

; create Playlist-Buttons
$hPLnew = GUICtrlCreateIcon($sIconDir & 'playlistnew0.ico', -1, 10, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Create new Playlist')
GUICtrlSetOnEvent(-1, '_NewPlaylist')
$hPLopen = GUICtrlCreateIcon($sIconDir & 'playlistopen0.ico', -1, 44, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Open Playlist')
GUICtrlSetOnEvent(-1, '_OpenPlaylist')
$hPLsave = GUICtrlCreateIcon($sIconDir & 'playlistsave0.ico', -1, 78, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Save Playlist')
GUICtrlSetOnEvent(-1, '_SavePlaylist')
$hPLadd = GUICtrlCreateIcon($sIconDir & 'playlistadd0.ico', -1, 112, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Add File(s) to Playlist')
GUICtrlSetOnEvent(-1, '_AddFile')
$hPLdel = GUICtrlCreateIcon($sIconDir & 'playlistdel0.ico', -1, 146, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Remove File(s) from Playlist')
GUICtrlSetOnEvent(-1, '_DelFile')
$hRandom = GUICtrlCreateIcon($sIconDir & 'random0.ico', -1, 180, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Playlist Randomsort')
GUICtrlSetOnEvent(-1, '_Randomsort')
$hRepeat = GUICtrlCreateIcon($sIconDir & 'repeat0.ico', -1, 214, 314, 32, 32)
GUICtrlSetOnEvent(-1, '_RepeatPlaylist')
$hExport = GUICtrlCreateIcon($sIconDir & 'export0.ico', -1, 248, 314, 32, 32)
If $bTooltips Then GUICtrlSetTip(-1, 'Export Playlist to...')
GUICtrlSetOnEvent(-1, '_ExportPlaylist')

; create Player-Buttons
$hPrev = GUICtrlCreateIcon($sIconDir & 'prev0.ico', -1, 300, 300, 48, 48)
If $bTooltips Then GUICtrlSetTip(-1, 'previous Title')
GUICtrlSetOnEvent(-1, '_PrevTitle')
$hStop = GUICtrlCreateIcon($sIconDir & 'stop0.ico', -1, 350, 300, 48, 48)
If $bTooltips Then GUICtrlSetTip(-1, 'Stop')
GUICtrlSetOnEvent(-1, '_StopTitle')
$hPlay = GUICtrlCreateIcon($sIconDir & 'play0.ico', -1, 400, 300, 48, 48)
If $bTooltips Then GUICtrlSetTip(-1, 'Play')
GUICtrlSetOnEvent(-1, '_PlayButton')
$hNext = GUICtrlCreateIcon($sIconDir & 'next0.ico', -1, 450, 300, 48, 48)
If $bTooltips Then GUICtrlSetTip(-1, 'next Title')
GUICtrlSetOnEvent(-1, '_NextTitle')

; create VU-Meter
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 0) ; Classic-Style
$hPeakL = GUICtrlCreateProgress(10, 360, 560, 10)
GUICtrlSetColor(-1, $iPeakColor)
GUICtrlSetBkColor(-1, $iPeakBKColor)
GUICtrlCreateLabel('Left', 575, 358, 50, 16)
$hPeakR = GUICtrlCreateProgress(10, 380, 560, 10)
GUICtrlSetColor(-1, $iPeakColor)
GUICtrlSetBkColor(-1, $iPeakBKColor)
GUICtrlCreateLabel('Right', 575, 378, 50, 16)
DllCall('uxtheme.dll', 'none', 'SetThemeAppProperties', 'int', 7) ; Standard-Windows-Style
GUICtrlSetData($hPeakL, 60)
GUICtrlSetData($hPeakR, 65)

; create Statusbar
$hStatus1 = GUICtrlCreateInput('', 0, 400, 200, 20, BitOR($ES_CENTER, $ES_READONLY), $WS_EX_CLIENTEDGE)
GUICtrlSetBkColor(-1, $iStatusBkColor)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
$hStatus2 = GUICtrlCreateInput('', 200, 400, 430, 20, $ES_READONLY, $WS_EX_CLIENTEDGE)
GUICtrlSetBkColor(-1, $iStatusBkColor)
GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')

; create Dummy-Control for Import
$hImport = GUICtrlCreateEdit('', 0, 420, 630, 200)
GUICtrlSetState(-1, $GUI_HIDE)

; Show GUI
GUISetState()

; Initialize
Global $bTimer1 = False, $bTimer2 = False
GUICtrlSetData($hVolControl, 100 - $iVolume)
_VolControl()
If $bRepeat Then
	GUICtrlSetImage($hRepeat, $sIconDir & 'repeat_active0.ico')
	If $bTooltips Then GUICtrlSetTip($hRepeat, 'Repeat Playlist')
Else
	GUICtrlSetImage($hRepeat, $sIconDir & 'repeat0.ico')
	If $bTooltips Then GUICtrlSetTip($hRepeat, 'Stop at Playlist-End')
EndIf
If $bOnTop Then
	WinSetOnTop($hGui, '', 1)
	GUICtrlSetState($hMOptionsOnTop, $GUI_CHECKED)
EndIf
If $bMin2Tray Then GUICtrlSetState($hMOptionsMin2Tray, $GUI_CHECKED)
If $bDblClPlay Then GUICtrlSetState($hMOptionsDblClPlay, $GUI_CHECKED)
_CalcPlaylistDuration()

; Create PrefGUI and Initialize VU-Meter
Global $EncHandle, $levelR, $levelL, $KHZ = 44100
$hPrefGui = GUICreate(' - VU-Meter Prefs -', 320, 160, -1, -1, $WS_CAPTION, Default, $hGui)
GUICtrlCreateLabel('Select AudioDevice:', 10, 10)
$hDevice = GUICtrlCreateCombo('', 10, 30, 300, 20, BitOR($CBS_DROPDOWN, $CBS_DROPDOWNLIST, $WS_VSCROLL))
GUICtrlCreateLabel('Select AudioInput:', 10, 60)
$hInput = GUICtrlCreateCombo('', 10, 80, 300, 20, BitOR($CBS_DROPDOWN, $CBS_DROPDOWNLIST, $WS_VSCROLL))
$hOk = GUICtrlCreateButton('Ok', 120, 120, 80, 20)
$device = _GetDevices()
_BASS_RecordInit($bass_dll, $device)
$input = _GetInputs()
$temp = DllCall($basscb_dll, 'dword', 'RecordStart', 'dword', $KHZ, 'dword', 2, 'dword', _makelong($BASS_SAMPLE_FX, 10))
$RecHandle = $temp[0]

; Register Messages
GUIRegisterMsg($WM_VSCROLL, '_WM_VSCROLL')
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
GUIRegisterMsg($WM_MOVE, '_WM_MOVE')
GUIRegisterMsg($WM_DROPFILES, '_WM_DROPFILES')
GUIRegisterMsg($WM_TIMER, '_WM_TIMER')
$iTimerDuration = _Timer_SetTimer($hGui, 250)
$iTimerVolume = _Timer_SetTimer($hGui, 1000)
$iTimerVUMeter = _Timer_SetTimer($hGui, 30)

; CommandLine-Parameter
If $CmdLine[0] > 0 Then
	For $i = 1 To $CmdLine[0]
		If FileExists($CmdLine[$i]) Then
			Switch StringRight($CmdLine[$i], 4)
				Case '.mp3'
					$iCount = UBound($ahLVItems)
					If $ahLVItems[0] = '' Then $iCount = 0
					ReDim $ahLVItems[$iCount + 1]
					_CreateLVItems($CmdLine[$i], $iCount, $i - 1)
				Case '.m3u'
					_OpenM3U($CmdLine[$i])
			EndSwitch
		EndIf
	Next
	If $hPlayHandle = -1 Then _PlayTitle(0)
	_CalcPlaylistDuration()
EndIf

; Infinite loop
While True
	Sleep(50)
	If StringRight(GUICtrlRead($hImport), 2) = @CRLF Then _ImportFiles()
WEnd

#cs
	********************************************************************************
	*   Begin Functions
	********************************************************************************
#ce

Func _End()
	If _BASS_Encode_IsActive($bass_dll, $bassenc_dll, $EncHandle) Then _BASS_Encode_Stop($bass_dll, $bassenc_dll, $EncHandle)
	_BASS_RecordFree($bass_dll)
	SoundSetWaveVolume($iStdVolume)
	ConsoleWrite('Killed All Timers? ' & _Timer_KillAllTimers($hGui) & @LF)
	If $hPlayHandle <> -1 Then
		_SoundStop($hPlayHandle)
		_SoundClose($hPlayHandle)
	EndIf
	Exit
EndFunc   ;==>_End

Func _VUMeter()
	Local $peak, $temp
	$peak = _BASS_ChannelGetLevel($bass_dll, $RecHandle)
	If Not @error Then
		$temp = (_LoWord($peak) / 32768) * 100
		If $temp > $levelL Then $levelL = $temp
		$temp = (_HiWord($peak) / 32768) * 100
		If $temp > $levelR Then $levelR = $temp
		GUICtrlSetData($hPeakL, $levelL)
		GUICtrlSetData($hPeakR, $levelR)
		$levelL -= 4
		$levelR -= 4
	EndIf
EndFunc

Func _SelectAudioDevice()
	Opt('GUIOnEventMode', 0)
	GUISetState(@SW_DISABLE, $hGui)
	WinMove($hPrefGui, '', $iMainPosX + 120, $iMainPosY + 40)
	GUISetState(@SW_SHOW, $hPrefGui)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $hOk
				ExitLoop
			Case $hDevice
				_SelectDevice()
			Case $hInput
				_SelectInput()
		EndSwitch
	WEnd
	IniWrite($sInifile, 'Settings', 'Audio-Device', Chr(34) & GUICtrlRead($hDevice) & Chr(34))
	IniWrite($sInifile, 'Settings', 'Audio-Input', Chr(34) & GUICtrlRead($hInput) & Chr(34))
	GUISetState(@SW_HIDE, $hPrefGui)
	GUISetState(@SW_ENABLE, $hGui)
	Opt('GUIOnEventMode', 1)
EndFunc   ;==>_SelectAudioDevice

Func _SelectDevice()
	Local $new = _GUICtrlComboBox_GetCurSel($hDevice)
	If $new = $device Then Return
	_BASS_RecordFree($bass_dll)
	_BASS_RecordSetDevice($bass_dll, $new)
	_BASS_Recordinit($bass_dll, $new)
	GUICtrlSetData($hInput, '', '')
	_GetInputs()
	$temp = DllCall($basscb_dll, 'dword', 'RecordStart', 'dword', $KHZ, 'dword', 2, 'dword', _makelong($BASS_SAMPLE_FX, 10))
	$RecHandle = $temp[0]
	$device = $new
EndFunc   ;==>_SelectDevice

Func _SelectInput()
	Local $new = _GUICtrlComboBox_GetCurSel($hInput)
	If $new = $input Then Return
	_BASS_RecordSetInput($bass_dll, $new, $BASS_INPUT_ON, -1)
	$input = $new
EndFunc   ;==>_SelectInput

Func _GetDevices()
	Local $count = 0, $info, $name = '', $sdef = '', $idef = 0, $sIni = ''
	While 1
		$info = _BASS_RecordGetDeviceInfo($bass_dll, $count)
		If @error Then ExitLoop
		$count += 1
		If BitAND($info[2], $BASS_DEVICE_ENABLED) Then $name &= $info[0] & '|'
		If BitAND($info[2], $BASS_DEVICE_DEFAULT) Then
			$sdef = $info[0]
			$idef = $count
		EndIf
	WEnd
	$sIni = IniRead($sInifile, 'Settings', 'Audio-Device', $sdef)
	If StringInStr($name, $sIni) Then $sdef = $sIni
	GUICtrlSetData($hDevice, $name, $sdef)
	Return $idef - 1
EndFunc   ;==>_GetDevices

Func _GetInputs()
	Local $count = 0, $info, $name = '', $flags, $sdef = '', $idef = 0, $sIni = ''
	$info = _BASS_RecordGetInputName($bass_dll, $count)
	While $info <> ''
		$flags = _BASS_RecordGetInput($bass_dll, $count)
		$count += 1
		$name &= $info & '|'
		If BitAND($flags[0], $BASS_INPUT_OFF) = 0 Then
			$sdef = $info
			$idef = $count
		EndIf
		$info = _BASS_RecordGetInputName($bass_dll, $count)
	WEnd
	$sIni = IniRead($sInifile, 'Settings', 'Audio-Input', $sdef)
	If StringInStr($name, $sIni) Then $sdef = $sIni
	GUICtrlSetData($hInput, $name, $sdef)
	Return $idef - 1
EndFunc   ;==>_GetInputs

Func _RegisterFiletype()
	If Not @Compiled Then Return MsgBox(48 + 262144, $sTitle, 'Error! Script must be compiled!', 0, $hGui)
	Local $sHKCUSoftware, $sFileType, $sFileTypeName, $sFileTypeDescriptopn, $sFileTypeIcon, $sFileTypeOpenCommand, $msg
	$sHKCUSoftware = 'HKEY_CURRENT_USER\Software\'
	$sFileTypeOpenCommand = Chr(34) & @ScriptFullPath & Chr(34) & ' "%1"'
	; Register MP3-Files .mp3
	$sFileType = '.mp3'
	$sFileTypeName = 'StarplayerMP3'
	$sFileTypeDescriptopn = 'Starplayer MP3 Audiodatei'
	$sFileTypeIcon = @ScriptDir & '\icons\mp3.ico,0'
	RegWrite($sHKCUSoftware & 'Microsoft\Windows\CurrentVersion\Explorer\FileExts\' & $sFileType, 'Progid', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, '', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'Content Type', 'REG_SZ', 'audio/mpeg')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'PerceivedType', 'REG_SZ', 'audio')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName, '', 'REG_SZ', $sFileTypeDescriptopn)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Defaulticon', '', 'REG_SZ', $sFileTypeIcon)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\open\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\play\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	; Register Playlist .m3u
	$sFileType = '.m3u'
	$sFileTypeName = 'StarplayerM3U'
	$sFileTypeDescriptopn = 'Starplayer MP3 Playlist'
	$sFileTypeIcon = @ScriptDir & '\icons\m3u.ico,0'
	RegWrite($sHKCUSoftware & 'Microsoft\Windows\CurrentVersion\Explorer\FileExts\' & $sFileType, 'Progid', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, '', 'REG_SZ', $sFileTypeName)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'Content Type', 'REG_SZ', 'audio/mpegurl')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileType, 'PerceivedType', 'REG_SZ', 'audio')
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName, '', 'REG_SZ', $sFileTypeDescriptopn)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Defaulticon', '', 'REG_SZ', $sFileTypeIcon)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\open\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	RegWrite($sHKCUSoftware & 'Classes\' & $sFileTypeName & '\Shell\play\command', '', 'REG_SZ', $sFileTypeOpenCommand)
	$msg = 'The extensions ".mp3" and ".m3u" are now registered to:' & @CRLF
	$msg &= 'Starplayer ("' & @ScriptFullPath & '")'
	MsgBox(64 + 262144, $sTitle, $msg, 0, $hGui)
EndFunc   ;==>_RegisterFiletype

Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $iwParam
	Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndListView
	$hWndListView = GUICtrlGetHandle($hListview)
	$tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
	$hWndFrom = HWnd(DllStructGetData($tNMHDR, 'hWndFrom'))
	$iIDFrom = DllStructGetData($tNMHDR, 'IDFrom')
	$iCode = DllStructGetData($tNMHDR, 'Code')
	Switch $hWndFrom
		Case $hWndListView
			Switch $iCode
				Case $NM_DBLCLK
					Local $iCount = UBound($ahLVItems) - 1
					If $iCount > 0 Then
						GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
						_PlayTitle(ControlListView($hGui, '', $hListview, 'GetSelected'))
					EndIf
					Return 0
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func _DblClPlay()
	$bDblClPlay = Not $bDblClPlay
	If $bDblClPlay Then
		GUICtrlSetState($hMOptionsDblClPlay, $GUI_CHECKED)
	Else
		GUICtrlSetState($hMOptionsDblClPlay, $GUI_UNCHECKED)
	EndIf
	IniWrite($sInifile, 'Settings', 'DblClPlay', $bDblClPlay)
EndFunc   ;==>_DblClPlay

Func _RepeatPlaylist()
	$bRepeat = Not $bRepeat
	If $bRepeat Then
		GUICtrlSetImage($hRepeat, $sIconDir & 'repeat_active1.ico')
		If $bTooltips Then GUICtrlSetTip($hRepeat, 'Repeat Playlist')
	Else
		GUICtrlSetImage($hRepeat, $sIconDir & 'repeat1.ico')
		If $bTooltips Then GUICtrlSetTip($hRepeat, 'Stop at Playlist-End')
	EndIf
	IniWrite($sInifile, 'Settings', 'PlaylistRepeat', $bRepeat)
EndFunc   ;==>_RepeatPlaylist

Func _PauseTitle()
	_SoundPause($hPlayHandle)
	$bPlayPause = True
	GUICtrlSetImage($hPlay, $sIconDir & 'pause_active.ico')
	If $bTooltips Then GUICtrlSetTip($hPlay, 'Resume')
	GUICtrlSetOnEvent($hPlay, '_ResumeTitle')
EndFunc   ;==>_PauseTitle

Func _ResumeTitle()
	_SoundResume($hPlayHandle)
	$bPlayPause = False
	GUICtrlSetImage($hPlay, $sIconDir & 'pause1.ico')
	If $bTooltips Then GUICtrlSetTip($hPlay, 'Pause')
	GUICtrlSetOnEvent($hPlay, '_PauseTitle')
EndFunc   ;==>_ResumeTitle

Func _PlayButton()
	Local $iSelected = ControlListView($hGui, '', $hListview, 'GetSelected')
	If $iSelected = '' Then $iSelected = 0
	_PlayTitle($iSelected)
EndFunc   ;==>_PlayButton

Func _PlayTitle($iSelected)
	Local $iLVCount, $sSoundPath, $sTitle, $sArtist
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	$iPlayIndexNr = Number($iSelected)
	$sSoundPath = _GUICtrlListView_GetItemText($hListview, $iPlayIndexNr, 5)
	If $hPlayHandle <> -1 Then
		$bTimer1 = False
		_SoundStop($hPlayHandle)
		_SoundClose($hPlayHandle)
	EndIf
	$hPlayHandle = _SoundOpen($sSoundPath, 'PlaySound')
	If @error Then Return $hPlayHandle = -1
	$sTitle = _GUICtrlListView_GetItemText($hListview, $iPlayIndexNr, 0)
	$sArtist = _GUICtrlListView_GetItemText($hListview, $iPlayIndexNr, 1)
	GUICtrlSetData($hDisplayTitle, $sTitle & ' - ' & $sArtist)
	GUICtrlSetImage($hPlay, $sIconDir & 'pause0.ico')
	GUICtrlSetOnEvent($hPlay, '_PauseTitle')
	If $bTooltips Then GUICtrlSetTip($hPlay, 'Pause')
	_SoundPlay($hPlayHandle)
	GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvMarkColor)
	_GUICtrlListView_EnsureVisible($hListview, $iPlayIndexNr)
	$bTimer1 = True
	_DisplayPosition()
EndFunc   ;==>_PlayTitle

Func _DisplayPosition()
	Local $iSoundPos, $iSoundLenght
	$iSoundPos = StringRight(_SoundPos($hPlayHandle, 1), 5)
	$iSoundLenght = StringRight(_SoundLength($hPlayHandle, 1), 5)
	If $iSoundPos <> $iOldPos Then
		$iOldPos = $iSoundPos
		GUICtrlSetData($hDisplayTime, $iSoundPos & ' / ' & $iSoundLenght)
		$iSoundPos = _SoundPos($hPlayHandle, 2)
		$iSoundLenght = _SoundLength($hPlayHandle, 2)
		GUICtrlSetData($hProgress, 100 / $iSoundLenght * $iSoundPos)
	EndIf
	If _SoundStatus($hPlayHandle) = 'stopped' Then _NextTitle()
EndFunc   ;==>_DisplayPosition

Func _WM_TIMER($hWnd, $iMsg, $iwParam, $ilParam)
	#forceref $hWnd, $iMsg, $ilParam
	Switch _Timer_GetTimerID($iwParam)
		Case $iTimerDuration
			If $bTimer1 Then _DisplayPosition()
		Case $iTimerVolume
			If $bTimer2 Then _CloseToolTip()
		Case $iTimerVUMeter
			_VUMeter()
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_TIMER

Func _StopTitle()
	If $hPlayHandle <> -1 Then
		$bTimer1 = False
		_SoundStop($hPlayHandle)
		_SoundClose($hPlayHandle)
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
		$bPlayPause = False
		GUICtrlSetImage($hPlay, $sIconDir & 'play0.ico')
		GUICtrlSetOnEvent($hPlay, '_PlayButton')
		If $bTooltips Then GUICtrlSetTip($hPlay, 'Play')
		$hPlayHandle = -1
		GUICtrlSetData($hDisplayTime, '00:00 / 00:00')
		GUICtrlSetData($hDisplayTitle, '')
		GUICtrlSetData($hProgress, 0)
	EndIf
EndFunc   ;==>_StopTitle

Func _NextTitle()
	If $hPlayHandle = -1 Then Return
	Local $iLVCount
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	If $iPlayIndexNr < ($iLVCount - 1) Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
		_PlayTitle($iPlayIndexNr + 1)
		Return
	EndIf
	If $iPlayIndexNr = ($iLVCount - 1) Then
		If $bRepeat Then
			GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
			_PlayTitle(0)
		Else
			_StopTitle()
		EndIf
	EndIf
EndFunc   ;==>_NextTitle

Func _PrevTitle()
	If $hPlayHandle = -1 Then Return
	Local $iLVCount
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	If $iPlayIndexNr > 0 Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
		_PlayTitle($iPlayIndexNr - 1)
		Return
	EndIf
	If $iPlayIndexNr = 0 And $bRepeat Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
		_PlayTitle($iLVCount - 1)
	EndIf
EndFunc   ;==>_PrevTitle

Func _NewPlaylist()
	If $hPlayHandle <> -1 Then _StopTitle()
	_GUICtrlListView_BeginUpdate($hListview)
	_GUICtrlListView_DeleteAllItems($hListview)
	_GUICtrlListView_EndUpdate($hListview)
	$iPlayIndexNr = -1
	ReDim $ahLVItems[1]
	$ahLVItems[0] = ''
	_CalcPlaylistDuration()
EndFunc   ;==>_NewPlaylist

Func _OpenPlaylist()
	Local $sPlaylist, $spath
	$sPlaylist = FileOpenDialog($sTitle, $sPathPlaylist, 'Playlist (*.m3u)', 1 + 2, '', $hGui)
	If @error Then Return
	$spath = StringRegExpReplace($sPlaylist, '(.*\\).*', '$1')
	IniWrite($sInifile, 'Settings', 'PathPlaylist', $spath)
	_OpenM3U($sPlaylist)
EndFunc   ;==>_OpenPlaylist

Func _OpenM3U($sPlaylist)
	Local $aMP3, $iCount
	If Not FileExists($sPlaylist) Then Return
	$aMP3 = StringSplit(FileRead($sPlaylist), @CRLF, 1)
	GUICtrlSetImage($hPLopen, $sIconDir & 'wait.ico')
	GUISetCursor(15, 1, $hGui)
	_GUICtrlListView_BeginUpdate($hListview)
	If IsArray($aMP3) Then
		For $i = 1 To $aMP3[0]
			If StringRight($aMP3[$i], 4) = '.mp3' And FileExists($aMP3[$i]) Then
				$iCount = UBound($ahLVItems)
				If $ahLVItems[0] = '' Then $iCount = 0
				ReDim $ahLVItems[$iCount + 1]
				_CreateLVItems($aMP3[$i], $iCount, 0)
			EndIf
		Next
		_GUICtrlListView_SetColumnWidth($hListview, 5, $LVSCW_AUTOSIZE)
		If $hPlayHandle = -1 Then _PlayTitle(0)
	EndIf
	_GUICtrlListView_EndUpdate($hListview)
	GUISetCursor(2, 1, $hGui)
	GUICtrlSetImage($hPLopen, $sIconDir & 'playlistopen0.ico')
	_CalcPlaylistDuration()
EndFunc   ;==>_OpenM3U

Func _SavePlaylist()
	Local $sPlaylist, $spath
	$sPlaylist = FileSaveDialog($sTitle, $sPathPlaylist, 'Playlist (*.m3u)', 16, '', $hGui)
	If @error Then Return
	If StringRight($sPlaylist, 4) <> '.m3u' Then $sPlaylist &= '.m3u'
	$spath = StringRegExpReplace($sPlaylist, '(.*\\).*', '$1')
	IniWrite($sInifile, 'Settings', 'PathPlaylist', $spath)
	_SaveM3U($sPlaylist)
EndFunc   ;==>_SavePlaylist

Func _SaveM3U($sPlaylist)
	Local $hFile, $iLVCount
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	$hFile = FileOpen($sPlaylist, 2)
	If $hFile <> -1 Then
		For $i = 0 To $iLVCount - 1
			FileWriteLine($hFile, _GUICtrlListView_GetItemText($hListview, $i, 5))
		Next
		FileClose($hFile)
	EndIf
EndFunc   ;==>_SaveM3U

Func _CalcPlaylistDuration()
	Local $iLVCount, $iPlDuration = 0, $aTime
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	$iPlSize = 0
	If $iLVCount > 0 Then
		For $i = 0 To $iLVCount - 1
			$aTime = StringSplit(_GUICtrlListView_GetItemText($hListview, $i, 3), ':', 2)
			If UBound($aTime) > 1 Then $iPlDuration += _TimeToTicks($aTime[0], $aTime[1], $aTime[2])
			$iPlSize += FileGetSize(_GUICtrlListView_GetItemText($hListview, $i, 5))
		Next
	EndIf
	GUICtrlSetData($hStatus1, $iLVCount & ' File' & _Iif($iLVCount <> 1, 's', '') & ' (' & _ByteAutoSize($iPlSize, 2, 0, False) & ')')
	GUICtrlSetData($hStatus2, '   Playlist total time = ' & _NewTicksToTime($iPlDuration, True))
EndFunc   ;==>_CalcPlaylistDuration

Func _AddFile()
	Local $sFiles, $aNewFiles, $spath, $iCount
	$sFiles = FileOpenDialog($sTitle, $sPathFiles, 'MP3-Files (*.mp3)', 1 + 2 + 4, '', $hGui)
	If @error Then Return
	$aNewFiles = StringSplit($sFiles, '|')
	If $aNewFiles[0] = 1 Then Local $aNewFiles[3] = [2, StringRegExpReplace($sFiles, '(.+\\).+', '$1'), StringRegExpReplace($sFiles, '.+\\(.+)', '$1')]
	If StringRight($aNewFiles[1], 1) <> '\' Then $aNewFiles[1] &= '\'
	$sPathFiles = $aNewFiles[1]
	IniWrite($sInifile, 'Settings', 'PathFiles', $sPathFiles)
	$iCount = UBound($ahLVItems)
	If $ahLVItems[0] = '' Then $iCount = 0
	ReDim $ahLVItems[$iCount + $aNewFiles[0] - 1]
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetImage($hPLadd, $sIconDir & 'wait.ico')
	_GUICtrlListView_BeginUpdate($hListview)
	For $i = 2 To $aNewFiles[0]
		$spath = $aNewFiles[1] & $aNewFiles[$i]
		_CreateLVItems($spath, $iCount, $i - 2)
	Next
	_GUICtrlListView_EndUpdate($hListview)
	_GUICtrlListView_SetColumnWidth($hListview, 5, $LVSCW_AUTOSIZE)
	If $hPlayHandle = -1 Then _PlayTitle(0)
	GUICtrlSetImage($hPLadd, $sIconDir & 'playlistadd0.ico')
	GUISetCursor(2, 1, $hGui)
	_CalcPlaylistDuration()
EndFunc   ;==>_AddFile

Func _ImportFiles()
	Local $aFiles
	$aFiles = StringSplit(StringTrimRight(GUICtrlRead($hImport), 2), @CRLF, 1)
	For $i = 1 To $aFiles[0]
		If FileExists($aFiles[$i]) Then
			Switch StringRight($aFiles[$i], 4)
				Case '.mp3'
					$iCount = UBound($ahLVItems)
					If $ahLVItems[0] = '' Then $iCount = 0
					ReDim $ahLVItems[$iCount + 1]
					_CreateLVItems($aFiles[$i], $iCount, 0)
				Case '.m3u'
					_OpenM3U($aFiles[$i])
			EndSwitch
		EndIf
	Next
	_GUICtrlListView_SetColumnWidth($hListview, 5, $LVSCW_AUTOSIZE)
	GUICtrlSetData($hImport, '')
	If $bDblClPlay Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iProgrBkColor)
		_PlayTitle(UBound($ahLVItems) - 1)
	Else
		If $hPlayHandle = -1 Then _PlayTitle(0)
		_CalcPlaylistDuration()
	EndIf
EndFunc   ;==>_ImportFiles

Func _CreateLVItems($spath, $iCount, $iLoop)
	Local $oDir, $oFile, $sID3Title, $sID3Artist, $sID3Duration, $sID3Bitrate, $sID3Album, $sTmp, $hSound
	$oDir = $oShellApp.NameSpace(StringLeft($spath, StringInStr($spath, '\', 1, -1)))
	$sTmp = StringTrimLeft($spath, StringInStr($spath, '\', 1, -1))
	$oFile = $oDir.Parsename($sTmp)
	$sID3Title = $oDir.GetDetailsOf($oFile, $aID3Index[0])
	If $sID3Title = '' Then $sID3Title = StringRegExpReplace($sTmp, '.+-(.+)\..+', '$1')
	$sID3Artist = $oDir.GetDetailsOf($oFile, $aID3Index[1])
	If $sID3Artist = '' Then $sID3Artist = StringLeft($sTmp, StringInStr($sTmp, '-', 1) - 1)
	$sID3Duration = $oDir.GetDetailsOf($oFile, $aID3Index[2])
	If Not StringRegExp($sID3Duration, '\d{2}:\d{2}:\d{2}') Then
		Local $aInfo = _GetMP3Info($spath)
		If StringRegExp($aInfo[5], '\d{2}:\d{2}:\d{2}') Then
			$sID3Duration = $aInfo[5]
		Else
			If Not @Compiled Then ConsoleWrite('_SoundLength-Function on: "' & $spath & '"' & @CR)
			$sID3Duration = _SoundLength($spath, 1)
		EndIf
	EndIf
	$sID3Bitrate = $oDir.GetDetailsOf($oFile, $aID3Index[3])
	$sID3Album = $oDir.GetDetailsOf($oFile, $aID3Index[4])
	$ahLVItems[$iCount + $iLoop] = GUICtrlCreateListViewItem($sID3Title & '|' & $sID3Artist & '|' & $sID3Album & '|' & $sID3Duration & '|' & $sID3Bitrate & '|' & $spath, $hListview)
EndFunc   ;==>_CreateLVItems

Func _DropEvent()
	Local $aNewFiles, $iCount
	GUIRegisterMsg($WM_DROPFILES, '')
	GUISetCursor(15, 1, $hGui)
	_GUICtrlListView_BeginUpdate($hListview)
	For $i = 0 To UBound($gaDropFiles) - 1
		If StringInStr(FileGetAttrib($gaDropFiles[$i]), 'D') Then
			If StringRight($gaDropFiles[$i], 1) <> '\' Then $gaDropFiles[$i] &= '\'
			$aNewFiles = _RecursiveFileListToArray($gaDropFiles[$i], '.+\.mp3', 1)
			If Not @error Then
				$iCount = UBound($ahLVItems)
				If $ahLVItems[0] = '' Then $iCount = 0
				ReDim $ahLVItems[$iCount + $aNewFiles[0]]
				For $j = 1 To $aNewFiles[0]
					_CreateLVItems($aNewFiles[$j], $iCount, $j - 1)
				Next
			EndIf
		Else
			If StringRight($gaDropFiles[$i], 4) = '.mp3' Then
				$iCount = UBound($ahLVItems)
				If $ahLVItems[0] = '' Then $iCount = 0
				ReDim $ahLVItems[$iCount + 1]
				_CreateLVItems($gaDropFiles[$i], $iCount, 0)
			EndIf
		EndIf
	Next
	_GUICtrlListView_EndUpdate($hListview)
	_GUICtrlListView_SetColumnWidth($hListview, 5, $LVSCW_AUTOSIZE)
	GUISetCursor(2, 1, $hGui)
	GUIRegisterMsg($WM_DROPFILES, '_WM_DROPFILES')
	If $hPlayHandle = -1 Then _PlayTitle(0)
	_CalcPlaylistDuration()
EndFunc   ;==>_DropEvent

Func _WM_DROPFILES($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $lParam
	Local $nSize, $pFileName
	Local $nAmt = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', 0xFFFFFFFF, 'ptr', 0, 'int', 255)
	For $i = 0 To $nAmt[0] - 1
		$nSize = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', 0, 'int', 0)
		$nSize = $nSize[0] + 1
		$pFileName = DllStructCreate('wchar[' & $nSize & ']')
		DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', DllStructGetPtr($pFileName), 'int', $nSize)
		ReDim $gaDropFiles[$i + 1]
		$gaDropFiles[$i] = DllStructGetData($pFileName, 1)
		$pFileName = 0
	Next
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_DROPFILES

Func _DelFile()
	Local $aSelected
	$aSelected = _GUICtrlListView_GetSelectedIndices($hListview, True)
	If $aSelected[0] = 0 Then Return
	For $i = $aSelected[0] To 1 Step -1
		If $aSelected[$i] = $iPlayIndexNr Then
			_StopTitle()
			$iPlayIndexNr = 0
		EndIf
		If $aSelected[$i] < $iPlayIndexNr Then $iPlayIndexNr -= 1
		_ArrayDelete($ahLVItems, $aSelected[$i])
	Next
	_GUICtrlListView_DeleteItemsSelected($hListview)
	_CalcPlaylistDuration()
EndFunc   ;==>_DelFile

Func _Randomsort()
	Local $iCount, $aRan, $aItems, $aTmp
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	Local $aRan[$iLVCount], $aItems[$iLVCount]
	_StopTitle()
	GUISetCursor(15, 1, $hGui)
	GUICtrlSetImage($hRandom, $sIconDir & 'wait.ico')
	_GUICtrlListView_BeginUpdate($hListview)
	For $i = 0 To UBound($aRan) - 1
		$aRan[$i] = Random(100000, 999999, 1)
		$aItems[$i] = _GUICtrlListView_GetItemTextString($hListview, $i)
	Next
	For $i = 0 To UBound($aRan) - 2
		For $j = $i + 1 To UBound($aRan) - 1
			If $aRan[$i] > $aRan[$j] Then
				_SwitchVar($aRan[$i], $aRan[$j])
				_SwitchVar($aItems[$i], $aItems[$j])
			EndIf
		Next
	Next
	For $i = 0 To UBound($aRan) - 1
		_GUICtrlListView_SetItemText($hListview, $i, $aItems[$i], -1)
	Next
	GUICtrlSetImage($hRandom, $sIconDir & 'random0.ico')
	_GUICtrlListView_EndUpdate($hListview)
	GUISetCursor(2, 1, $hGui)
	_PlayTitle(0)
EndFunc   ;==>_Randomsort

Func _SwitchVar(ByRef $a, ByRef $b)
	Local $tmp
	$tmp = $a
	$a = $b
	$b = $tmp
EndFunc   ;==>_SwitchVar

Func _ButtonRepeat()
	Local $aInfo, $iRepeatTimer
	$aInfo = GUIGetCursorInfo($hGui)
	If @error Then Return SetError(1, 0, 0)
	If $aInfo[4] = $hUp Or $aInfo[4] = $hDown Then
		$iRepeatTimer = TimerInit()
		While $aInfo[2]
			If TimerDiff($iRepeatTimer) > $iButtonDownDelay Then
				Switch $aInfo[4]
					Case $hUp
						_SelUp()
					Case $hDown
						_SelDown()
				EndSwitch
				Sleep($iButtonRepeatDelay)
			EndIf
			$aInfo = GUIGetCursorInfo($hGui)
		WEnd
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_ButtonRepeat

Func _SelUp()
	Local $iCount, $aSelected, $sTmp
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	$aSelected = _GUICtrlListView_GetSelectedIndices($hListview, True)
	If $aSelected[0] = 0 Or $aSelected[1] = 0 Then Return
	If $aSelected[1] - 1 = $iPlayIndexNr Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvBkColor)
		$iPlayIndexNr = $aSelected[1]
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvMarkColor)
	ElseIf $aSelected[1] = $iPlayIndexNr Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvBkColor)
		$iPlayIndexNr = $aSelected[1] - 1
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvMarkColor)
	EndIf
	$sTmp = _GUICtrlListView_GetItemTextString($hListview, $aSelected[1] - 1)
	_GUICtrlListView_SetItemText($hListview, $aSelected[1] - 1, _GUICtrlListView_GetItemTextString($hListview, $aSelected[1]), -1)
	_GUICtrlListView_SetItemText($hListview, $aSelected[1], $sTmp, -1)
	_GUICtrlListView_SetItemSelected($hListview, -1, False)
	_GUICtrlListView_SetItemSelected($hListview, $aSelected[1] - 1, True)
	_GUICtrlListView_EnsureVisible($hListview, $aSelected[1] - 1)
EndFunc   ;==>_SelUp

Func _SelDown()
	Local $iCount, $aSelected, $sTmp
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	$aSelected = _GUICtrlListView_GetSelectedIndices($hListview, True)
	If $aSelected[0] = 0 Or $aSelected[1] = $iLVCount - 1 Then Return
	If $aSelected[1] + 1 = $iPlayIndexNr Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvBkColor)
		$iPlayIndexNr = $aSelected[1]
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvMarkColor)
	ElseIf $aSelected[1] = $iPlayIndexNr Then
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvBkColor)
		$iPlayIndexNr = $aSelected[1] + 1
		GUICtrlSetBkColor($ahLVItems[$iPlayIndexNr], $iLvMarkColor)
	EndIf
	$sTmp = _GUICtrlListView_GetItemTextString($hListview, $aSelected[1] + 1)
	_GUICtrlListView_SetItemText($hListview, $aSelected[1] + 1, _GUICtrlListView_GetItemTextString($hListview, $aSelected[1]), -1)
	_GUICtrlListView_SetItemText($hListview, $aSelected[1], $sTmp, -1)
	_GUICtrlListView_SetItemSelected($hListview, -1, False)
	_GUICtrlListView_SetItemSelected($hListview, $aSelected[1] + 1, True)
	_GUICtrlListView_EnsureVisible($hListview, $aSelected[1] + 1)
EndFunc   ;==>_SelDown

Func _ExportPlaylist()
	Local $sDir, $iLVCount, $spath, $sFile, $sMsg, $sList = ''
	$iLVCount = _GUICtrlListView_GetItemCount($hListview)
	If $iLVCount = 0 Then Return
	$sMsg = 'Select folder to export Playlist-Files' & @CRLF & _ByteAutoSize($iPlSize, 2, 0, False) & ' space required.'
	$sDir = FileSelectFolder($sMsg, '', 3, $sPathExport, $hGui)
	If @error Or (Not FileExists($sDir)) Then Return
	GUICtrlSetImage($hExport, $sIconDir & 'wait.ico')
	If StringRight($sDir, 1) <> '\' Then $sDir &= '\'
	For $i = 0 To $iLVCount - 1
		$spath = _GUICtrlListView_GetItemText($hListview, $i, 5)
		$sFile = StringMid($spath, StringInStr($spath, '\', 0, -1) + 1)
		$sList &= $sFile & @CRLF
		GUICtrlSetData($hStatus2, ' Copy "' & $sFile & '"')
		FileCopy($spath, $sDir, 1)
	Next
	GUICtrlSetData($hStatus2, ' Create Playlist...')
	$hFile = FileOpen($sDir & 'Export-Playlist.m3u', 2)
	If $hFile <> -1 Then
		FileWrite($hFile, $sList)
		FileClose($hFile)
	EndIf
	$sPathExport = $sDir
	IniWrite($sInifile, 'Settings', 'PathExport', $sPathExport)
	GUICtrlSetData($hStatus2, ' Ready.')
	Sleep(1000)
	GUICtrlSetImage($hExport, $sIconDir & 'export0.ico')
	_CalcPlaylistDuration()
EndFunc   ;==>_ExportPlaylist

Func _WM_VSCROLL($hWnd, $iMsg, $wParam, $lParam)
	#forceref $iMsg, $wParam
	If $hWnd = $hGui Then
		If $lParam = GUICtrlGetHandle($hVolControl) Then _VolControl()
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_VSCROLL

Func _VolControl()
	Local $aPos = ControlGetPos($hGui, '', $hVolControl)
	$iVolume = 100 - GUICtrlRead($hVolControl)
	GUICtrlSetData($hVolDisplay, $iVolume)
	ToolTip('Volume =' & StringFormat('%6s', $iVolume & '%'), $iMainPosX + $aPos[0] - 24, $iMainPosY + $aPos[1] + 30)
	SoundSetWaveVolume($iVolume)
	If $iVolume = 0 Then
		GUICtrlSetBkColor($hVolDisplay, $iVolProgrMuteColor)
	Else
		GUICtrlSetBkColor($hVolDisplay, $iVolProgrBkColor)
	EndIf
	GUICtrlSetState($hVolControl, $GUI_FOCUS)
	$bTimer2 = True
EndFunc   ;==>_VolControl

Func _CloseToolTip()
	$bTimer2 = False
	IniWrite($sInifile, 'Settings', 'Volume', $iVolume)
	ToolTip('')
EndFunc   ;==>_CloseToolTip

Func _VolMute()
	$bMute = Not $bMute
	If $bMute Then
		GUICtrlSetState($hVolControl, $GUI_DISABLE)
		$iMuteVol = $iVolume
		GUICtrlSetData($hVolControl, 100)
		GUICtrlSetImage($hVolIcon, $sIconDir & 'mute.ico')
	Else
		GUICtrlSetState($hVolControl, $GUI_ENABLE)
		GUICtrlSetData($hVolControl, 100 - $iMuteVol)
		GUICtrlSetImage($hVolIcon, $sIconDir & 'volcontrol1.ico')
	EndIf
	_VolControl()
	GUICtrlSetState($hVolControl, $GUI_FOCUS)
EndFunc   ;==>_VolMute

Func _WM_MOVE($hWnd, $iMsg, $wParam, $lParam)
	#forceref $iMsg, $wParam, $lParam
	If $hWnd = $hGui Then
		If Not BitAND(WinGetState($hGui), 16) Then
			Local $aPos = WinGetPos($hGui)
			$iMainPosX = $aPos[0]
			$iMainPosY = $aPos[1]
			IniWrite($sInifile, 'Settings', 'MainPosX', $iMainPosX)
			IniWrite($sInifile, 'Settings', 'MainPosY', $iMainPosY)
		EndIf
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_MOVE

Func _SetPos()
	Local $aInfo, $iSoundLenght
	$aInfo = GUIGetCursorInfo($hGui)
	If @error Then Return SetError(1, 0, 0)
	Switch $aInfo[4]
		Case $hProgress
			If $hPlayHandle <> -1 Then
				Local $aProgrPos = ControlGetPos($hGui, '', $hProgress)
				$iPlayPosition = 100 / $aProgrPos[2] * ($aInfo[0] - $aProgrPos[0])
				$iSoundLenght = _SoundLength($hPlayHandle, 2)
				$aSoundLenght = _NewTicksToTime($iSoundLenght / 100 * $iPlayPosition)
				_SoundSeek($hPlayHandle, $aSoundLenght[1], $aSoundLenght[2], $aSoundLenght[3])
				_SoundPlay($hPlayHandle)
				_DisplayPosition()
			EndIf
		Case $hVolDisplay
			Local $aVolPos = ControlGetPos($hGui, '', $hVolDisplay)
			GUICtrlSetData($hVolControl, 100 / $aVolPos[3] * ($aInfo[1] - $aVolPos[1]))
			_VolControl()
		Case $hUp, $hDown
			Return
		Case $hListview
			If $bMute Then
				GUICtrlSetImage($hVolIcon, $sIconDir & 'mute.ico')
			Else
				GUICtrlSetImage($hVolIcon, $sIconDir & 'volcontrol0.ico')
			EndIf
			Return
	EndSwitch
	_GUICtrlListView_SetItemSelected($hListview, -1, False)
	GUICtrlSetState($hVolControl, $GUI_FOCUS)
	If $bMute Then
		GUICtrlSetImage($hVolIcon, $sIconDir & 'mute.ico')
	Else
		GUICtrlSetImage($hVolIcon, $sIconDir & 'volcontrol1.ico')
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_SetPos

Func _MouseHover()
	Local $aInfo = GUIGetCursorInfo($hGui)
	If @error Then Return SetError(1, 0, 0)
	If $aInfo[4] <> $iOldHoverID Then
		Switch $iOldHoverID
			Case $hPrev
				GUICtrlSetImage($hPrev, $sIconDir & 'prev0.ico')
			Case $hStop
				GUICtrlSetImage($hStop, $sIconDir & 'stop0.ico')
			Case $hPlay
				If $hPlayHandle = -1 Then
					GUICtrlSetImage($hPlay, $sIconDir & 'play0.ico')
				Else
					If $bPlayPause Then
						GUICtrlSetImage($hPlay, $sIconDir & 'pause_active.ico')
					Else
						GUICtrlSetImage($hPlay, $sIconDir & 'pause0.ico')
					EndIf
				EndIf
			Case $hNext
				GUICtrlSetImage($hNext, $sIconDir & 'next0.ico')
			Case $hPLnew
				GUICtrlSetImage($hPLnew, $sIconDir & 'playlistnew0.ico')
			Case $hPLopen
				GUICtrlSetImage($hPLopen, $sIconDir & 'playlistopen0.ico')
			Case $hPLsave
				GUICtrlSetImage($hPLsave, $sIconDir & 'playlistsave0.ico')
			Case $hPLadd
				GUICtrlSetImage($hPLadd, $sIconDir & 'playlistadd0.ico')
			Case $hPLdel
				GUICtrlSetImage($hPLdel, $sIconDir & 'playlistdel0.ico')
			Case $hRandom
				GUICtrlSetImage($hRandom, $sIconDir & 'random0.ico')
			Case $hRepeat
				If $bRepeat Then
					GUICtrlSetImage($hRepeat, $sIconDir & 'repeat_active0.ico')
				Else
					GUICtrlSetImage($hRepeat, $sIconDir & 'repeat0.ico')
				EndIf
			Case $hExport
				GUICtrlSetImage($hExport, $sIconDir & 'export0.ico')
			Case $hUp
				GUICtrlSetImage($hUp, $sIconDir & 'up0.ico')
			Case $hDown
				GUICtrlSetImage($hDown, $sIconDir & 'down0.ico')
		EndSwitch
		Switch $aInfo[4]
			Case $hPrev
				GUICtrlSetImage($hPrev, $sIconDir & 'prev1.ico')
			Case $hStop
				GUICtrlSetImage($hStop, $sIconDir & 'stop1.ico')
			Case $hPlay
				If $hPlayHandle = -1 Then
					GUICtrlSetImage($hPlay, $sIconDir & 'play1.ico')
				Else
					If $bPlayPause Then
						GUICtrlSetImage($hPlay, $sIconDir & 'pause_active.ico')
					Else
						GUICtrlSetImage($hPlay, $sIconDir & 'pause1.ico')
					EndIf
				EndIf
			Case $hNext
				GUICtrlSetImage($hNext, $sIconDir & 'next1.ico')
			Case $hPLnew
				GUICtrlSetImage($hPLnew, $sIconDir & 'playlistnew1.ico')
			Case $hPLopen
				GUICtrlSetImage($hPLopen, $sIconDir & 'playlistopen1.ico')
			Case $hPLsave
				GUICtrlSetImage($hPLsave, $sIconDir & 'playlistsave1.ico')
			Case $hPLadd
				GUICtrlSetImage($hPLadd, $sIconDir & 'playlistadd1.ico')
			Case $hPLdel
				GUICtrlSetImage($hPLdel, $sIconDir & 'playlistdel1.ico')
			Case $hRandom
				GUICtrlSetImage($hRandom, $sIconDir & 'random1.ico')
			Case $hRepeat
				If $bRepeat Then
					GUICtrlSetImage($hRepeat, $sIconDir & 'repeat_active1.ico')
				Else
					GUICtrlSetImage($hRepeat, $sIconDir & 'repeat1.ico')
				EndIf
			Case $hExport
				GUICtrlSetImage($hExport, $sIconDir & 'export1.ico')
			Case $hUp
				GUICtrlSetImage($hUp, $sIconDir & 'up1.ico')
			Case $hDown
				GUICtrlSetImage($hDown, $sIconDir & 'down1.ico')
		EndSwitch
		$iOldHoverID = $aInfo[4]
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_MouseHover

Func _Min2Tray()
	$bMin2Tray = Not $bMin2Tray
	If $bMin2Tray Then
		GUICtrlSetState($hMOptionsMin2Tray, $GUI_CHECKED)
	Else
		GUICtrlSetState($hMOptionsMin2Tray, $GUI_UNCHECKED)
	EndIf
	IniWrite($sInifile, 'Settings', 'Min2Tray', $bMin2Tray)
EndFunc   ;==>_Min2Tray

Func _Minimize()
	WinSetOnTop($hGui, '', 0)
	If $bMin2Tray Then
		Opt('TrayIconHide', 0)
		TraySetToolTip($sTitle)
		GUISetState(@SW_HIDE, $hGui)
	EndIf
EndFunc   ;==>_Minimize

Func _Restore()
	If $bOnTop Then WinSetOnTop($hGui, '', 1)
	Opt('TrayIconHide', 1)
	GUISetState(@SW_SHOW, $hGui)
	GUISetState(@SW_RESTORE, $hGui)
EndFunc   ;==>_Restore

Func _SetOnTop()
	$bOnTop = Not $bOnTop
	If $bOnTop Then
		WinSetOnTop($hGui, '', 1)
		GUICtrlSetState($hMOptionsOnTop, $GUI_CHECKED)
	Else
		WinSetOnTop($hGui, '', 0)
		GUICtrlSetState($hMOptionsOnTop, $GUI_UNCHECKED)
	EndIf
	IniWrite($sInifile, 'Settings', 'OnTop', $bOnTop)
EndFunc   ;==>_SetOnTop

Func _VersionOld($sVersion1, $sVersion2)
	$sVersion1 = Number(StringRegExpReplace($sVersion1, '(\d)\.(\d)\.(\d)\.(\d).+', '$1$2$3$4'))
	$sVersion2 = Number(StringRegExpReplace($sVersion2, '(\d)\.(\d)\.(\d)\.(\d).+', '$1$2$3$4'))
	Return $sVersion1 < $sVersion2
EndFunc   ;==>_VersionOld

Func _SoundGetWaveVolume()
	Local $WaveVol = -1, $p, $ret
	Local Const $MMSYSERR_NOERROR = 0
	$p = DllStructCreate('dword')
	If @error Then Return SetError(2, 0, -2)
	$ret = DllCall('winmm.dll', 'long', 'waveOutGetVolume', 'long', -1, 'long', DllStructGetPtr($p))
	If ($ret[0] == $MMSYSERR_NOERROR) Then
		$WaveVol = Round(Dec(StringRight(Hex(DllStructGetData($p, 1), 8), 4)) / 0xFFFF * 100)
	Else
		SetError(1)
	EndIf
	$p = 0
	Return $WaveVol
EndFunc   ;==>_SoundGetWaveVolume

Func _GetDesktopResolution()
	Local $aRes[4], $hWindow, $stRET
	$hWindow = _WinAPI_GetDesktopWindow()
	$stRET = _WinAPI_GetWindowPlacement($hWindow)
	If Not @error Then
		$aRes[0] = DllStructGetData($stRET, 'rcNormalPosition', 1) ; left
		$aRes[1] = DllStructGetData($stRET, 'rcNormalPosition', 2) ; top
		$aRes[2] = DllStructGetData($stRET, 'rcNormalPosition', 3) ; right
		$aRes[3] = DllStructGetData($stRET, 'rcNormalPosition', 4) ; bottom
		$stRET = 0
		Return $aRes
	Else
		Return SetError(1, 0, 0)
	EndIf
EndFunc   ;==>_GetDesktopResolution

Func _NewTicksToTime($iTicks, $iStringFormat = False)
	Local $iDays, $iHours, $iMins, $iSecs = Int($iTicks / 1000)
	$iDays = Int($iSecs / 86400)
	$iSecs = Mod($iSecs, 86400)
	$iHours = Int($iSecs / 3600)
	$iSecs = Mod($iSecs, 3600)
	$iMins = Int($iSecs / 60)
	$iSecs = Mod($iSecs, 60)
	If $iStringFormat Then Return '  ' & $iDays & ' day' & _Iif($iDays <> 1, 's', '') & StringFormat(' %02i:%02i:%02i', $iHours, $iMins, $iSecs)
	Local $aTime[4] = [$iDays, $iHours, $iMins, $iSecs]
	Return $aTime
EndFunc   ;==>_NewTicksToTime

Func _ByteAutoSize($iSize, $iRound = 2, $iFormat = 0, $bThousands = True)
	Local $aSize[4] = [' Byte', ' KByte', ' MByte', ' GByte'], $sReturn
	If $iFormat < 0 Or $iFormat > 4 Then $iFormat = 0
	If $iRound < 0 Or $iRound > 8 Then $iRound = 2
	If Not IsBool($bThousands) Then $bThousands = False
	$iSize = Abs($iSize)
	If $iFormat = 0 Then
		For $i = 30 To 0 Step -10
			If $iSize > (2 ^ $i) Then
				$iFormat = $i / 10 + 1
				ExitLoop
			EndIf
		Next
	EndIf
	If $iFormat = 0 Then $iFormat = 1
	$sReturn = StringFormat('%.' & $iRound & 'f', Round($iSize / (2 ^ (($iFormat - 1) * 10)), $iRound))
	If $bThousands Then $sReturn = _StringAddThousandsSep($sReturn, ',', '.')
	Return $sReturn & $aSize[$iFormat - 1]
EndFunc   ;==>_ByteAutoSize

Func _RecursiveFileListToArray($spath, $sPattern = '', $iFlag = 0, $iFormat = 1, $iRecursion = 1, $sDelim = @CRLF)
	Local $hSearch, $sFile, $sReturn = ''
	If StringRight($spath, 1) <> '\' Then $spath &= '\'
	$hSearch = FileFindFirstFile($spath & '*.*')
	If @error Or $hSearch = -1 Then Return SetError(1, 0, $sReturn)
	While True
		$sFile = FileFindNextFile($hSearch)
		If @error Then ExitLoop
		If StringInStr(FileGetAttrib($spath & $sFile), 'D') Then
			If StringRegExp($spath & $sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 2) Then $sReturn &= $spath & $sFile & '\' & $sDelim
			If $iRecursion Then $sReturn &= _RecursiveFileListToArray($spath & $sFile & '\', $sPattern, $iFlag, 0)
			ContinueLoop
		EndIf
		If StringRegExp($sFile, $sPattern) And ($iFlag = 0 Or $iFlag = 1) Then $sReturn &= $spath & $sFile & $sDelim
	WEnd
	FileClose($hSearch)
	If $iFormat And $sReturn = '' Then Return StringSplit($sReturn, '', $iFormat)
	If $iFormat Then Return StringSplit(StringTrimRight($sReturn, StringLen($sDelim)), $sDelim, $iFormat)
	Return $sReturn
EndFunc   ;==>_RecursiveFileListToArray
